/*
** Unobtrusive validation support library for jQuery and jQuery Validate
** Copyright (C) Microsoft Corporation. All rights reserved.
*/
(function(J){var M=J.validator,K,G="unobtrusiveValidation";function D(P,Q,O){P.rules[Q]=O;if(P.message){P.messages[Q]=P.message}}function A(O){return O.replace(/^\s+|\s+$/g,"").split(/\s*,\s*/g)}function N(O){return O.replace(/([!"#$%&'()*+,./:;<=>?@\[\\\]^`{|}~])/g,"\\$1")}function L(O){return O.substr(0,O.lastIndexOf(".")+1)}function F(P,O){if(P.indexOf("*.")===0){P=P.replace("*.",O)}return P}function C(Q,R){var P=J(this).find("[data-valmsg-for='"+N(R[0].name)+"']"),O=J.parseJSON(P.attr("data-valmsg-replace"))!==false;P.removeClass("field-validation-valid").addClass("field-validation-error");Q.data("unobtrusiveContainer",P);if(O){P.empty();Q.removeClass("input-validation-error").appendTo(P)}else{Q.hide()}}function H(Q,R){var P=J(this).find("[data-valmsg-summary=true]"),O=P.find("ul");if(O&&O.length&&R.errorList.length){O.empty();P.addClass("validation-summary-errors").removeClass("validation-summary-valid");J.each(R.errorList,function(){J("<li />").html(this.message).appendTo(O)})}}function B(Q){var P=Q.data("unobtrusiveContainer"),O=J.parseJSON(P.attr("data-valmsg-replace"));if(P){P.addClass("field-validation-valid").removeClass("field-validation-error");Q.removeData("unobtrusiveContainer");if(O){P.empty()}}}function I(P){var O=J(this);O.data("validator").resetForm();O.find(".validation-summary-errors").addClass("validation-summary-valid").removeClass("validation-summary-errors");O.find(".field-validation-error").addClass("field-validation-valid").removeClass("field-validation-error").removeData("unobtrusiveContainer").find(">*").removeData("unobtrusiveContainer")}function E(P){var O=J(P),R=O.data(G),Q=J.proxy(I,P);if(!R){R={options:{errorClass:"input-validation-error",errorElement:"span",errorPlacement:J.proxy(C,P),invalidHandler:J.proxy(H,P),messages:{},rules:{},success:J.proxy(B,P)},attachValidation:function(){O.unbind("reset."+G,Q).bind("reset."+G,Q).validate(this.options)},validate:function(){O.validate();return O.valid()}};O.data(G,R)}return R}M.unobtrusive={adapters:[],parseElement:function(U,R){var O=J(U),S=O.parents("form")[0],Q,T,P;if(!S){return}Q=E(S);Q.options.rules[U.name]=T={};Q.options.messages[U.name]=P={};J.each(this.adapters,function(){var W="data-val-"+this.name,X=O.attr(W),V={};if(X!==undefined){W+="-";J.each(this.params,function(){V[this]=O.attr(W+this)});this.adapt({element:U,form:S,message:X,params:V,rules:T,messages:P})}});J.extend(T,{"__dummy__":true});if(!R){Q.attachValidation()}},parse:function(P){var O=J(P).parents("form").andSelf().add(J(P).find("form")).filter("form");J(P).find(":input[data-val=true]").each(function(){M.unobtrusive.parseElement(this,true)});O.each(function(){var Q=E(this);if(Q){Q.attachValidation()}})}};K=M.unobtrusive.adapters;K.add=function(Q,P,O){if(!O){O=P;P=[]}this.push({name:Q,params:P,adapt:O});return this};K.addBool=function(P,O){return this.add(P,function(Q){D(Q,O||P,true)})};K.addMinMax=function(T,R,P,Q,S,O){return this.add(T,[S||"min",O||"max"],function(V){var U=V.params.min,W=V.params.max;if(U&&W){D(V,Q,[U,W])}else{if(U){D(V,R,U)}else{if(W){D(V,P,W)}}}})};K.addSingleVal=function(Q,O,P){return this.add(Q,[O||"val"],function(R){D(R,P||Q,R.params[O])})};M.addMethod("__dummy__",function(O,P,Q){return true});M.addMethod("regex",function(P,Q,R){var O;if(this.optional(Q)){return true}O=new RegExp(R).exec(P);return(O&&(O.index===0)&&(O[0].length===P.length))});M.addMethod("nonalphamin",function(Q,R,O){var P;if(O){P=Q.match(/\W/g);P=P&&P.length>=O}return P});K.addSingleVal("accept","exts").addSingleVal("regex","pattern");K.addBool("creditcard").addBool("date").addBool("digits").addBool("email").addBool("number").addBool("url");K.addMinMax("length","minlength","maxlength","rangelength").addMinMax("range","min","max","range");K.add("equalto",["other"],function(Q){var P=L(Q.element.name),S=Q.params.other,O=F(S,P),R=J(Q.form).find(":input[name='"+N(O)+"']")[0];D(Q,"equalTo",R)});K.add("required",function(O){if(O.element.tagName.toUpperCase()!=="INPUT"||O.element.type.toUpperCase()!=="CHECKBOX"){D(O,"required",true)}});K.add("remote",["url","type","additionalfields"],function(P){var Q={url:P.params.url,type:P.params.type||"GET",data:{}},O=L(P.element.name);J.each(A(P.params.additionalfields||P.element.name),function(R,S){var T=F(S,O);Q.data[T]=function(){return J(P.form).find(":input[name='"+N(T)+"']").val()}});D(P,"remote",Q)});K.add("password",["min","nonalphamin","regex"],function(O){if(O.params.min){D(O,"minlength",O.params.min)}if(O.params.nonalphamin){D(O,"nonalphamin",O.params.nonalphamin)}if(O.params.regex){D(O,"regex",O.params.regex)}});J(function(){M.unobtrusive.parse(document)})}(jQuery));